package ru.dbotthepony.kstarbound.defs.item

import com.google.gson.GsonBuilder
import ru.dbotthepony.kstarbound.io.KConcreteTypeAdapter
import ru.dbotthepony.kstarbound.registerTypeAdapter

data class ItemDefinition(
	val itemName: String,
	val price: Long = 0L,
	val rarity: ItemRarity = ItemRarity.COMMON,
	val category: String? = null,
	val inventoryIcon: String? = null,
	val description: String = "...",
	val shortdescription: String = "...",
	val itemTags: List<String> = listOf()
) {
	companion object {
		val ADAPTER = KConcreteTypeAdapter.Builder(ItemDefinition::class)
			.plain(ItemDefinition::itemName)
			.plain(ItemDefinition::price)
			.plain(ItemDefinition::rarity)
			.plain(ItemDefinition::category)
			.plain(ItemDefinition::inventoryIcon)
			.plain(ItemDefinition::description)
			.plain(ItemDefinition::shortdescription)
			.list(ItemDefinition::itemTags)
			.build()

		fun registerGson(gsonBuilder: GsonBuilder) {
			gsonBuilder.registerTypeAdapter(ADAPTER)
		}
	}
}
